Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# GeomVertexData Class Reference

This defines the actual numeric vertex data stored in a Geom, in the structure defined by a particular GeomVertexFormat object. More...

Inheritance diagram for GeomVertexData:

List of all members.

## Public Member Functions
| GeomVertexData (GeomVertexData const copy)
| GeomVertexData (GeomVertexData const copy, GeomVertexFormat const format)
| This constructor copies all of the basic properties of the source VertexData, like usage_hint and animation tables, but does not copy the actual data, and it allows you to specify a different format.
| GeomVertexData (string name, GeomVertexFormat const format, UsageHint usage_hint)
GeomVertexData const | animateVertices (bool force, Thread current_thread)
| Returns a GeomVertexData that represents the results of computing the vertex animation on the CPU for this GeomVertexData.
| clearAnimatedVertices ()
| Removes the cache of animated vertices computed by a previous call to animate_vertices() within the same frame.
| clearCache ()
| Removes all of the previously-cached results of convert_to().
| clearCacheStage ()
| Removes all of the previously-cached results of convert_to(), at the current pipeline stage and upstream.
| clearRows ()
| Removes all of the rows from the arrays; functionally equivalent to set_num_rows(0) (but faster).
| clearSliderTable ()
| Sets the SliderTable pointer to NULL, removing the table from the vertex data.
| clearTransformBlendTable ()
| Sets the TransformBlendTable pointer to NULL, removing the table from the vertex data.
| clearTransformTable ()
| Sets the TransformTable pointer to NULL, removing the table from the vertex data.
int | compareTo (GeomVertexData const other)
| Returns 0 if the two objects are equivalent, even if they are not the same pointer.
GeomVertexData const | convertTo (GeomVertexFormat const new_format)
| Returns a new GeomVertexData that represents the same contents as this one, with all data types matched up name-by-name to the indicated new format.
| copyFrom (GeomVertexData const source, bool keep_data_objects, Thread current_thread)
| Copies all the data from the other array into the corresponding data types in this array, by matching data types name-by-name.
| copyFrom (GeomVertexData const source, bool keep_data_objects)
| Copies all the data from the other array into the corresponding data types in this array, by matching data types name-by-name.
| copyRowFrom (int dest_row, GeomVertexData const source, int source_row, Thread current_thread)
| Copies a single row of the data from the other array into the indicated row of this array.
| describeVertex (ostream out, int row)
| Writes a verbose, human-friendly description of the indicated vertex number.
GeomVertexArrayData const | getArray (int i)
| Returns a const pointer to the vertex data for the indicated array, for application code to directly examine (but not modify) the underlying vertex data.
list | getArrays ()
GeomVertexFormat const | getFormat ()
| Returns a pointer to the GeomVertexFormat structure that defines this data.
UpdateSeq | getModified (Thread current_thread)
| Returns a sequence number which is guaranteed to change at least every time the vertex data is modified.
UpdateSeq | getModified ()
| Returns a sequence number which is guaranteed to change at least every time the vertex data is modified.
string | getName ()
| Returns the name passed to the constructor, if any.
int | getNumArrays ()
| Returns the number of individual arrays stored within the data.
int | getNumBytes ()
| Returns the total number of bytes consumed by the different arrays of the vertex data.
int | getNumRows ()
| Returns the number of rows stored within all the arrays.
SliderTable const | getSliderTable ()
| Returns a const pointer to the SliderTable assigned to this data.
TransformBlendTable const | getTransformBlendTable ()
| Returns a const pointer to the TransformBlendTable assigned to this data.
TransformTable const | getTransformTable ()
| Returns a const pointer to the TransformTable assigned to this data.
UsageHint | getUsageHint ()
| Returns the usage hint that was passed to the constructor, and which will be passed to each array data object created initially, and arrays created as the result of a convert_to() operation.
bool | hasColumn (InternalName const name)
| Returns true if the data has the named column, false otherwise.
GeomVertexArrayData | modifyArray (int i)
| Returns a modifiable pointer to the indicated vertex array, so that application code may directly manipulate the data.
TransformBlendTable | modifyTransformBlendTable ()
| Returns a modifiable pointer to the current TransformBlendTable on this vertex data, if any, or NULL if there is not a TransformBlendTable.
| operator new (unsigned int size)
GeomVertexData | operator= (GeomVertexData const copy)
| The copy assignment operator is not pipeline-safe.
| output (ostream out)
GeomVertexData | replaceColumn (InternalName name, int num_components, NumericType numeric_type, Contents contents)
| Returns a new GeomVertexData object, suitable for modification, with the indicated data type replaced with a new table filled with undefined values.
bool | requestResident ()
| Returns true if the vertex data is currently resident in memory.
bool | reserveNumRows (int n)
| This ensures that enough memory space for n rows is allocated, so that you may increase the number of rows to n without causing a new memory allocation.
GeomVertexData const | reverseNormals ()
| Returns a new GeomVertexData object with the normal data modified in-place, so that each lighting normal is now facing in the opposite direction.
GeomVertexData const | scaleColor (VBase4 const color_scale, int num_components, NumericType numeric_type, Contents contents)
| Returns a new GeomVertexData object with the color table replaced with a new color table that has been scaled by the indicated value.
GeomVertexData const | scaleColor (VBase4 const color_scale)
| Returns a new GeomVertexData object with the color table modified in-place to apply the indicated scale.
| setArray (int i, GeomVertexArrayData const array)
| Replaces the indicated vertex data array with a completely new array.
GeomVertexData const | setColor (VBase4 const color, int num_components, NumericType numeric_type, Contents contents)
| Returns a new GeomVertexData object with the color table replaced with a new color table for which each vertex has the indicated value.
GeomVertexData const | setColor (VBase4 const color)
| Returns a new GeomVertexData object with the color data modified in-place with the new value.
| setFormat (GeomVertexFormat const format)
| Changes the format of the vertex data.
| setName (string name)
| Changes the name of the vertex data.
bool | setNumRows (int n)
| Sets the length of the array to n rows in all of the various arrays (presumably by adding rows).
| setSliderTable (SliderTable const table)
| Replaces the SliderTable on this vertex data with the indicated table.
| setTransformBlendTable (TransformBlendTable const table)
| Replaces the TransformBlendTable on this vertex data with the indicated table.
| setTransformTable (TransformTable const table)
| Replaces the TransformTable on this vertex data with the indicated table.
| setUsageHint (UsageHint usage_hint)
| Changes the UsageHint hint for this vertex data, and for all of the arrays that share this data.
| transformVertices (Mat4 const mat)
| Applies the indicated transform matrix to all of the vertices in the GeomVertexData.
| transformVertices (Mat4 const mat, int begin_row, int end_row)
| Applies the indicated transform matrix to all of the vertices from begin_row up to but not including end_row.
bool | uncleanSetNumRows (int n)
| This method behaves like set_num_rows(), except the new data is not initialized.
| write (ostream out)
| write (ostream out, int indent_level)
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

This defines the actual numeric vertex data stored in a Geom, in the structure defined by a particular GeomVertexFormat object.

The data consists of one or more arrays, each of which in turn consists of a series of rows, one per vertex. All arrays should have the same number of rows; each vertex is defined by the column data from a particular row across all arrays.

Often, there will be only one array per Geom, and the various columns defined in the GeomVertexFormat will be interleaved within that array. However, it is also possible to have multiple different arrays, with a certain subset of the total columns defined in each array.

However the data is distributed, the effect is of a single table of vertices, where each vertex is represented by one row of the table.

In general, application code should not attempt to directly manipulate the vertex data through this structure; instead, use the GeomVertexReader, GeomVertexWriter, and GeomVertexRewriter objects to read and write vertex data at a high level.

## Constructor & Destructor Documentation

GeomVertexData | ( | GeomVertexData const | copy | ) |

GeomVertexData | ( | GeomVertexData const | copy,
|  | GeomVertexFormat const | format
| ) |  |

This constructor copies all of the basic properties of the source VertexData, like usage_hint and animation tables, but does not copy the actual data, and it allows you to specify a different format.

GeomVertexData | ( | string | name,
|  | GeomVertexFormat const | format,
|  | UsageHint | usage_hint
| ) |  |

## Member Function Documentation

GeomVertexData const animateVertices | ( | bool | force,
|  | Thread | current_thread
| ) |  |

Returns a GeomVertexData that represents the results of computing the vertex animation on the CPU for this GeomVertexData.

If there is no CPU-defined vertex animation on this object, this just returns the original object.

If there is vertex animation, but the VertexTransform values have not changed since last time, this may return the same pointer it returned previously. Even if the VertexTransform values have changed, it may still return the same pointer, but with its contents modified (this is preferred, since it allows the graphics backend to update vertex buffers optimally).

If force is false, this method may return immediately with stale data, if the vertex data is not completely resident. If force is true, this method will never return stale data, but may block until the data is available.

clearAnimatedVertices | ( |  | ) |

Removes the cache of animated vertices computed by a previous call to animate_vertices() within the same frame.

This will force the next call to animate_vertices() to recompute these values from scratch. Normally it is not necessary to call this.

clearCache | ( |  | ) |

Removes all of the previously-cached results of convert_to().

This blows away the entire cache, upstream and downstream the pipeline. Use clear_cache_stage() instead if you only want to blow away the cache at the current stage and upstream.

clearCacheStage | ( |  | ) |

Removes all of the previously-cached results of convert_to(), at the current pipeline stage and upstream.

Does not affect the downstream cache.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

clearRows | ( |  | ) |

Removes all of the rows from the arrays; functionally equivalent to set_num_rows(0) (but faster).

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

clearSliderTable | ( |  | ) |

Sets the SliderTable pointer to NULL, removing the table from the vertex data.

This disables morph (blend shape) animation.

clearTransformBlendTable | ( |  | ) |

Sets the TransformBlendTable pointer to NULL, removing the table from the vertex data.

This disables CPU-driven vertex animation.

clearTransformTable | ( |  | ) |

Sets the TransformTable pointer to NULL, removing the table from the vertex data.

This disables hardware-driven vertex animation.

int compareTo | ( | GeomVertexData const | other | ) |

Returns 0 if the two objects are equivalent, even if they are not the same pointer.

GeomVertexData const convertTo | ( | GeomVertexFormat const | new_format | ) |

Returns a new GeomVertexData that represents the same contents as this one, with all data types matched up name-by-name to the indicated new format.

copyFrom | ( | GeomVertexData const | source,
|  | bool | keep_data_objects
| ) |  |

Copies all the data from the other array into the corresponding data types in this array, by matching data types name-by-name.

keep_data_objects specifies what to do when one or more of the arrays can be copied without the need to apply any conversion operation. If it is true, the original GeomVertexArrayData objects in this object are retained, and their data arrays are copied byte-by-byte from the source; if it is false, then the GeomVertexArrayData objects are copied pointerwise from the source.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

copyFrom | ( | GeomVertexData const | source,
|  | bool | keep_data_objects,
|  | Thread | current_thread
| ) |  |

Copies all the data from the other array into the corresponding data types in this array, by matching data types name-by-name.

keep_data_objects specifies what to do when one or more of the arrays can be copied without the need to apply any conversion operation. If it is true, the original GeomVertexArrayData objects in this object are retained, and their data arrays are copied byte-by-byte from the source; if it is false, then the GeomVertexArrayData objects are copied pointerwise from the source.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

copyRowFrom | ( | int | dest_row,
|  | GeomVertexData const | source,
|  | int | source_row,
|  | Thread | current_thread
| ) |  |

Copies a single row of the data from the other array into the indicated row of this array.

In this case, the source format must exactly match the destination format.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

describeVertex | ( | ostream | out,
|  | int | row
| ) |  |

Writes a verbose, human-friendly description of the indicated vertex number.

GeomVertexArrayData const getArray | ( | int | i | ) |

Returns a const pointer to the vertex data for the indicated array, for application code to directly examine (but not modify) the underlying vertex data.

list getArrays | ( |  | ) |

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from CopyOnWriteObject.

GeomVertexFormat const getFormat | ( |  | ) |

Returns a pointer to the GeomVertexFormat structure that defines this data.

UpdateSeq getModified | ( |  | ) |

Returns a sequence number which is guaranteed to change at least every time the vertex data is modified.

UpdateSeq getModified | ( | Thread | current_thread | ) |

Returns a sequence number which is guaranteed to change at least every time the vertex data is modified.

string getName | ( |  | ) |

Returns the name passed to the constructor, if any.

This name is reported on the PStats graph for vertex computations.

int getNumArrays | ( |  | ) |

Returns the number of individual arrays stored within the data.

This must match get_format()->get_num_arrays().

int getNumBytes | ( |  | ) |

Returns the total number of bytes consumed by the different arrays of the vertex data.

int getNumRows | ( |  | ) |

Returns the number of rows stored within all the arrays.

All arrays store data for the same n rows.

SliderTable const getSliderTable | ( |  | ) |

Returns a const pointer to the SliderTable assigned to this data.

Vertices within the vertex data will look up their morph offsets, if any, within this table.

This will return NULL if the vertex data does not have a SliderTable assigned.

TransformBlendTable const getTransformBlendTable | ( |  | ) |

Returns a const pointer to the TransformBlendTable assigned to this data.

Vertices within the table will index into this table to indicate their dynamic skinning information; this table is used when the vertex animation is to be performed by the CPU (but also see get_transform_table()).

This will return NULL if the vertex data does not have a TransformBlendTable assigned (which implies the vertices will not be animated by the CPU).

TransformTable const getTransformTable | ( |  | ) |

Returns a const pointer to the TransformTable assigned to this data.

Vertices within the table will index into this table to indicate their dynamic skinning information; this table is used when the vertex animation is to be performed by the graphics hardware (but also see get_transform_blend_table()).

This will return NULL if the vertex data does not have a TransformTable assigned (which implies the vertices will not be animated by the graphics hardware).

UsageHint getUsageHint | ( |  | ) |

Returns the usage hint that was passed to the constructor, and which will be passed to each array data object created initially, and arrays created as the result of a convert_to() operation.

See geomEnums.h.

However, each individual array may be replaced with a different array object with an independent usage hint specified, so there is no guarantee that the individual arrays all have the same usage_hint.

bool hasColumn | ( | InternalName const | name | ) |

Returns true if the data has the named column, false otherwise.

This is really just a shortcut for asking the same thing from the format.

GeomVertexArrayData modifyArray | ( | int | i | ) |

Returns a modifiable pointer to the indicated vertex array, so that application code may directly manipulate the data.

You should avoid changing the length of this array, since all of the arrays should be kept in sync--use set_num_rows() instead.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

TransformBlendTable modifyTransformBlendTable | ( |  | ) |

Returns a modifiable pointer to the current TransformBlendTable on this vertex data, if any, or NULL if there is not a TransformBlendTable.

See get_transform_blend_table().

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

operator new | ( | unsigned int | size | ) |

GeomVertexData operator= | ( | GeomVertexData const | copy | ) |

The copy assignment operator is not pipeline-safe.

This will completely obliterate all stages of the pipeline, so don't do it for a GeomVertexData that is actively being used for rendering.

output | ( | ostream | out | ) |

GeomVertexData replaceColumn | ( | InternalName | name,
|  | int | num_components,
|  | NumericType | numeric_type,
|  | Contents | contents
| ) |  |

Returns a new GeomVertexData object, suitable for modification, with the indicated data type replaced with a new table filled with undefined values.

The new table will be added as a new array; if the old table was interleaved with a previous array, the previous array will not be repacked.

If num_components is 0, the indicated name is simply removed from the type, without replacing it with anything else.

bool requestResident | ( |  | ) |

Returns true if the vertex data is currently resident in memory.

If this returns false, the vertex data will be brought back into memory shortly; try again later.

bool reserveNumRows | ( | int | n | ) |

This ensures that enough memory space for n rows is allocated, so that you may increase the number of rows to n without causing a new memory allocation.

This is a performance optimization only; it is especially useful when you know ahead of time that you will be adding n rows to the data.

GeomVertexData const reverseNormals | ( |  | ) |

Returns a new GeomVertexData object with the normal data modified in-place, so that each lighting normal is now facing in the opposite direction.

If the vertex data does not include a normal column, this returns the original GeomVertexData object, unchanged.

GeomVertexData const scaleColor | ( | VBase4 const | color_scale,
|  | int | num_components,
|  | NumericType | numeric_type,
|  | Contents | contents
| ) |  |

Returns a new GeomVertexData object with the color table replaced with a new color table that has been scaled by the indicated value.

The new color table will be added as a new array; if the old color table was interleaved with a previous array, the previous array will not be repacked.

GeomVertexData const scaleColor | ( | VBase4 const | color_scale | ) |

Returns a new GeomVertexData object with the color table modified in-place to apply the indicated scale.

If the vertex data does not include a color column, a new one will not be added.

setArray | ( | int | i,
|  | GeomVertexArrayData const | array
| ) |  |

Replaces the indicated vertex data array with a completely new array.

You should be careful that the new array has the same length and format as the old one, unless you know what you are doing.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

GeomVertexData const setColor | ( | VBase4 const | color | ) |

Returns a new GeomVertexData object with the color data modified in-place with the new value.

If the vertex data does not include a color column, a new one will not be added.

GeomVertexData const setColor | ( | VBase4 const | color,
|  | int | num_components,
|  | NumericType | numeric_type,
|  | Contents | contents
| ) |  |

Returns a new GeomVertexData object with the color table replaced with a new color table for which each vertex has the indicated value.

The new color table will be added as a new array; if the old color table was interleaved with a previous array, the previous array will not be repacked.

setFormat | ( | GeomVertexFormat const | format | ) |

Changes the format of the vertex data.

If the data is not empty, this will implicitly change every row to match the new format.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

setName | ( | string | name | ) |

Changes the name of the vertex data.

This name is reported on the PStats graph for vertex computations.

bool setNumRows | ( | int | n | ) |

Sets the length of the array to n rows in all of the various arrays (presumably by adding rows).

The new vertex data is initialized to 0, except for the "color" column, which is initialized to (1, 1, 1, 1).

The return value is true if the number of rows was changed, false if the object already contained n rows (or if there was some error).

Although this method is Published, application code only very rarely has any need to call it. Instead, you should use the GeomVertexWriter to build up the rows in a GeomVertexData object automatically, without need to explicitly set the number of rows.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

setSliderTable | ( | SliderTable const | table | ) |

Replaces the SliderTable on this vertex data with the indicated table.

There should be an entry in this table for each kind of morph offset defined in the vertex data.

The SliderTable object must have been registered prior to setting it on the GeomVertexData.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

setTransformBlendTable | ( | TransformBlendTable const | table | ) |

Replaces the TransformBlendTable on this vertex data with the indicated table.

The length of this table should be consistent with the maximum table index assigned to the vertices under the "transform_blend" name.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

setTransformTable | ( | TransformTable const | table | ) |

Replaces the TransformTable on this vertex data with the indicated table.

The length of this table should be consistent with the maximum table index assigned to the vertices under the "transform_index" name.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

setUsageHint | ( | UsageHint | usage_hint | ) |

Changes the UsageHint hint for this vertex data, and for all of the arrays that share this data.

See get_usage_hint().

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

transformVertices | ( | Mat4 const | mat,
|  | int | begin_row,
|  | int | end_row
| ) |  |

Applies the indicated transform matrix to all of the vertices from begin_row up to but not including end_row.

The transform is applied to all "point" and "vector" type columns described in the format.

transformVertices | ( | Mat4 const | mat | ) |

Applies the indicated transform matrix to all of the vertices in the GeomVertexData.

The transform is applied to all "point" and "vector" type columns described in the format.

bool uncleanSetNumRows | ( | int | n | ) |

This method behaves like set_num_rows(), except the new data is not initialized.

Furthermore, after this call, *any* of the data in the GeomVertexData may be uninitialized, including the earlier rows.

This is intended for applications that are about to completely fill the GeomVertexData with new data anyway; it provides a tiny performance boost over set_num_rows().

Although this method is Published, application code only very rarely has any need to call it. Instead, you should use the GeomVertexWriter to build up the rows in a GeomVertexData object automatically, without need to explicitly set the number of rows.

write | ( | ostream | out,
|  | int | indent_level
| ) |  |

write | ( | ostream | out | ) |

All Classes Namespaces Functions Variables Enumerations Enumerator Properties